//
// Copyright (c) 2011-2012, Matthijs van Leeuwen
//
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
// 
// Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
// Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
// Neither the name of the Universiteit Utrecht, KU Leuven, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 
#ifndef __DATAFILE_H
#define __DATAFILE_H

#include <Primitives.h>

enum DataFileType {
	DataFileTypeNone = 0,
	DataFileTypeArff,
};

class Column;
class DataSet;
class DataFile;

class DataFile {
public:
	DataFile();
	virtual ~DataFile();

	// Pure virtual
	virtual DataSet		*Read(string filename) =0;
	virtual void		CacheDataSetForWrite(DataSet *ds) =0;
	virtual void		CachedWriteExtraColumn(const string &dsName, Column *extraColumn, string path = "") =0;
	virtual void		CachedWriteExtraBool(const string &dsName, bool *boolValues, string path = "") =0;
	virtual void		CachedWriteDataSubset(const string &dsName, uint32 *ids, uint32 numRows, string path = "") =0;
	virtual void		CleanupCache() =0;

	// Static
	static DataFileType	StringToType(const string &desc);
	static DataFileType	ExtToType(const string &extension);
	static string		TypeToExt(const DataFileType dbType);

	static DataFile*	Create(DataFileType type);

protected:
};

#endif // __DATAFILE_H
