//
// Copyright (c) 2011-2012, Matthijs van Leeuwen
//
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
// 
// Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
// Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
// Neither the name of the Universiteit Utrecht, KU Leuven, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 
#ifndef __UINT32ARRAYSUBSET_H
#define __UINT32ARRAYSUBSET_H

#include "DataSubset.h"

class BinaryColumn;

class Uint32ArraySubset : public DataSubset {
public:
	Uint32ArraySubset(DataSet *ds);
	Uint32ArraySubset(DataSet *ds, bool *mask, const bool takeOwnership);
	Uint32ArraySubset(Uint32ArraySubset *datasubset);
	virtual ~Uint32ArraySubset();

	virtual DataSubset		*Clone();

	virtual void		AddToSubset(const uint32 row);
	virtual bool		IsInSubset(const uint32 row);
	virtual void		RemoveFromSubset(const uint32 row);
	virtual bool		Equals(DataSubset *subset);

	// Caller should delete array.
	virtual uint32		*GetRowsInSubset();
	// Caller should delete array.
	virtual uint32		*GetRowIdsInSubset();
	// Caller should delete.
	virtual BinaryColumn *GetBinaryColumn();
	// Caller should not delete.
	virtual uint32		*GetArray() { return mSubsetArray; }

protected:
	uint32	SearchInArray(const uint32 row);

	uint32	*mSubsetArray;

	friend class DataSubset;
};

#endif // __UINT32ARRAYSUBSET_H
